%:- include(array).
%:- include(builtins_ga).

first_paqueens(A,N):-
	paqueens(A,N,_),write_array(A,'%5d',0).

max_paqueens(A,N):-
	N2 is (N*N) //4,
	fd_domain(M,1,N2),
%	M#=5,
	paqueens_sbds(A,N,var(M)),
	write_array(A,'%5d',0),nl,
	%fd_maximize((paqueens(A,N,M)),M),write_array(A,'%5d',0),nl,
	write('Max value='),write(M),nl
	.
		
paqueens(A,N,M):-
	create_array(N,N,A),
	flatten(A,AllSquares),

%	write('main 01'-M),nl,
	fd_domain(AllSquares,0,2),
%	write('main 04'),nl,

	attackedsquare(A,1,1,N),
%	write('main 05'),nl,

%	list_const(AllSquares,1,Blacks),	
%	list_const(AllSquares,2,Whites),	
	
	fd_labeling([M],[value_method(max)]),
%	write('main 06'-M),nl,
	fd_exactly(M,AllSquares,2),
	fd_exactly(M,AllSquares,1),
	N2 is N*N-2*M,
	fd_exactly(N2,AllSquares,0),
	

%	write('main 07'),nl,
%	append(AllSquares,[M],L2),
	fd_labelingff(AllSquares).

paqueens_sbds(A,N,var(M)):-!,
%	write('main 06'),nl,
	create_array(N,N,A),
	flatten(A,AllSquares),

	fd_domain(AllSquares,0,2),

	attackedsquare(A,1,1,N),

	
	fd_labeling([M],[value_method(max)]),
%	write('main 06'-M),nl,
	fd_exactly(M,AllSquares,2),
	fd_exactly(M,AllSquares,1),
	N2 is N*N-2*M,
	fd_exactly(N2,AllSquares,0),
	
%	write('main 07'),nl,
	sym_glob([sym_val(all_var,[1,2])],LSym_1_2),
	LSym_geo=[vert_arr,hor_arr,diag1_arr,diag2_arr,rot90_arr,rot180_arr,rot270_arr],
	LSym_comp=[vert_paq,hor_paq,diag1_paq,diag2_paq,rot90_paq,rot180_paq,rot270_paq],
	flatten([LSym_1_2,LSym_geo,LSym_comp],LSym),
%	append(AllSquares,[M],L2),
%	labeling_sbds(AllSquares,[vert,hor,diag1,diag2,rot90,rot180,rot270],[]).
	labeling_sbds(AllSquares,LSym,[N],[]).
	
paqueens_sbds(A,N,M):- % ici M est un nombre
	write('M est un nb'),nl,
	create_array(N,N,A),
	flatten(A,AllSquares),

	fd_domain(AllSquares,0,2),

	attackedsquare(A,1,1,N),
	fd_exactly(M,AllSquares,2),
	fd_exactly(M,AllSquares,1),
	N2 is N*N-2*M,
	fd_exactly(N2,AllSquares,0),
	
	sym_val(all_var,[1,2],LSym_1_2),
	LSym_geo=[vert_arr,hor_arr,diag1_arr,diag2_arr,rot90_arr,rot180_arr,rot270_arr],
	LSym_comp=[vert_paq,hor_paq,diag1_paq,diag2_paq,rot90_paq,rot180_paq,rot270_paq],
	flatten([LSym_1_2,LSym_geo,LSym_comp],LSym),
%	append(AllSquares,[M],L2),
%	labeling_sbds(AllSquares,[vert,hor,diag1,diag2,rot90,rot180,rot270],[]).
	write('toto'),nl,
	randomize,
	labeling_sbds(AllSquares,LSym,[N],[var_order(middle),val_order(min)]).
	
attackedsquare(_,N,N,N):-!.
attackedsquare(A,I1,N,N):-!,
	I2 is I1+1,
	attacked_row(A,I1,N,I2,N),
	I1n is I1+1,
	attackedsquare(A,I1n,N,N).
attackedsquare(A,N,J1,N):-!,
	J2 is J1+1,
	attacked_col(A,N,J1,J2,N),
	I2 is N-1,
	attacked_diag2(A,N,J1,I2,J2,N),
	J1n is J1+1,
	attackedsquare(A,1,J1n,N).
attackedsquare(A,I1,J1,N):-
%	write('att square 01'),nl,
	I2 is I1+1,
	attacked_row(A,I1,J1,I2,N),
%	write('att square 02'),nl,
	J2 is J1+1,
	attacked_col(A,I1,J1,J2,N),
%	write('att square 03'),nl,
	attacked_diag(A,I1,J1,I2,J2,N),
	I22 is I1-1,
	attacked_diag2(A,I1,J1,I22,J2,N),
%	write('att square 04'),nl,
	I1n is I1+1,
	attackedsquare(A,I1n,J1,N).

attacked_row(A,I1,J1,N,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,N,J1,P2),
	P1+P2#\=3.
%	write('Row '-I1-J1-N-J1),nl.
attacked_row(A,I1,J1,I2,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,I2,J1,P2),
	P1+P2#\=3,
%	write('Row '-I1-J1-I2-J1),nl,
	I2n is I2+1,
	attacked_row(A,I1,J1,I2n,N).

	
attacked_col(A,I1,J1,N,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,I1,N,P2),
	P1+P2#\=3.
%	write('Col '-I1-J1-I1-N),nl.
attacked_col(A,I1,J1,J2,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,I1,J2,P2),
	P1+P2#\=3,
%	write('Col '-I1-J1-I1-J2),nl,
	J2n is J2+1,
	attacked_col(A,I1,J1,J2n,N).	
	
attacked_diag(A,I1,J1,I2,N,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,I2,N,P2),
	P1+P2#\=3.
%	write('Diag1 '-I1-J1-I2-N),nl.
attacked_diag(A,I1,J1,N,J2,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,N,J2,P2),
	P1+P2#\=3.
%	write('Diag1 '-I1-J1-N-J2),nl.
attacked_diag(A,I1,J1,I2,J2,N):-
	array_elem(A,I1,J1,P1),
	array_elem(A,I2,J2,P2),
	P1+P2#\=3,
%	write('Diag1 '-I1-J1-I2-J2),nl,
	I2n is I2+1,
	J2n is J2+1,
	attacked_diag(A,I1,J1,I2n,J2n,N).	


attacked_diag2(_,1,_,_,_,_):-!.
attacked_diag2(A,I1,J1,I2,N,N):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,I2,N,P2),
	P1+P2#\=3.
%	write('Diag2 '-I1-J1-I2-N),nl.
attacked_diag2(A,I1,J1,1,J2,_):-!,
	array_elem(A,I1,J1,P1),
	array_elem(A,1,J2,P2),
	P1+P2#\=3.
%	write('Diag2 '-I1-J1-1-J2),nl.
attacked_diag2(A,I1,J1,I2,J2,N):-
	array_elem(A,I1,J1,P1),
	array_elem(A,I2,J2,P2),
	P1+P2#\=3,
%	write('Diag2 '-I1-J1-I2-J2),nl,
	I2n is I2-1,
	J2n is J2+1,
	attacked_diag2(A,I1,J1,I2n,J2n,N).	

%%%%%%%%%%%%
list_const([],_,[]).
list_const([S|L],Val,[S#=Val|L2]):-
	list_const(L,Val,L2).
