// SBDS en GNU Prolog
// Guillaume Arnaud
// Date : 06/05/2003
// Decision du point de choix

#include "gprolog.h"
#include "stdlib.h"

static int bound_side;

void value_choice_c(int method, int size, int *val)
{
	srand(time(NULL));
	
	switch(method){
		case 1 :	*val=1;	break; // min
		case 2 :	*val=size; break; // max
		case 3 :	*val=size/2+1;break; // middle
		case 4 :	if(bound_side) // bound
					{*val=1;bound_side=0;}
				else	{*val=size;bound_side=1;}
				break;
		case 5 :	*val=(rand()%size)+1;break; // random
	}
}
