schur(L,N):-
	length(L,N),
	fd_domain(L,1,3),
	no_same_box(L,1,N),!,
	fd_labeling(L).

schur_sbds(L,N):-
	length(L,N),
	fd_domain(L,1,3),
	no_same_box(L,1,N),!,
%	sym_glob([sym_val(all_var,[1,2,3])],Sym),
	liste_num(LVar,1,N),
	Sym=[group([sym(varval,LVar,[0,2,1,3]),sym(varval,LVar,[0,2,3,1])])],
%	Sym=[sym(varval,LVar,[0,2,1,3]),sym(varval,LVar,[0,1,3,2]),sym(varval,LVar,[0,3,2,1]),sym(varval,LVar,[0,2,3,1]),sym(varval,LVar,[0,3,1,2])],
	fd_labeling_sbds(L,Sym).

no_same_box(_,N,N).
no_same_box(L,I,N):-
%	write('toto'),nl,
	Ip1 is I+1,
	no_same_box_P1_P2_P3(L,I,Ip1,N),
	no_same_box(L,Ip1,N).

no_same_box_P1_P2_P3(_,I,Ip1,N):-
	S is I+Ip1,
	S>N,!.
no_same_box_P1_P2_P3(L,I1,I2,N):-
	I3 is I1+I2,
	nth(I1,L,V1),
	nth(I2,L,V2),
	nth(I3,L,V3),
	fd_at_most_one([V1#=V2,V1#=V3,V2#=V3]),
	I2p1 is I2+1,
	no_same_box_P1_P2_P3(L,I1,I2p1,N).
	
	
